#!/usr/bin/env python
# -*- coding: utf-8 -*-

import wx
from core.config import config

class AddSmileDialog(wx.Dialog):
	def __init__(self, *args, **kwds):
		# begin wxGlade: AddGroupDialog.__init__
		kwds["style"] = wx.DEFAULT_DIALOG_STYLE
		wx.Dialog.__init__(self, *args, **kwds)
		self.urlLbl = wx.StaticText(self, -1, config.instance().localization[u"Smile's url"])
		self.urlText = wx.TextCtrl(self, -1, "", size = (300, -1))
		self.okBtn = wx.Button(self, wx.ID_OK, "")
		self.cancelBtn = wx.Button(self, wx.ID_CANCEL, "")

		self.__set_properties()
		self.__do_layout()
		# end wxGlade
		
		self.Bind(wx.EVT_BUTTON, self.OnOk, id = wx.ID_OK)

	def __set_properties(self):
		# begin wxGlade: AddGroupDialog.__set_properties
		self.SetTitle(config.instance().localization[u"Add new smile"])
		# end wxGlade

	def __do_layout(self):
		# begin wxGlade: AddGroupDialog.__do_layout
		sizer_1 = wx.BoxSizer(wx.VERTICAL)
		grid_sizer_2 = wx.FlexGridSizer(1, 2, 0, 0)
		grid_sizer_1 = wx.FlexGridSizer(1, 2, 0, 0)
		grid_sizer_1.Add(self.urlLbl, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 5)
		grid_sizer_1.Add(self.urlText, 0, wx.ALL|wx.EXPAND, 5)
		grid_sizer_1.AddGrowableCol(1)
		sizer_1.Add(grid_sizer_1, 1, wx.EXPAND, 0)
		grid_sizer_2.Add(self.okBtn, 0, wx.ALL, 5)
		grid_sizer_2.Add(self.cancelBtn, 0, wx.ALL, 5)
		sizer_1.Add(grid_sizer_2, 1, wx.ALL|wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM, 0)
		self.SetSizer(sizer_1)
		sizer_1.Fit(self)
		self.Layout()
		# end wxGlade
	
	@staticmethod	
	def isGoodExtension (url):
		exList = config.instance().smileextensions
		googEx = reduce(lambda x, y: x or y, [url.lower().endswith (ex) for ex in exList])
		return googEx
			
	def OnOk (self, event):
		url = self.urlText.GetValue()
		if self.urlText.GetValue() != "":
			# Проверить, что это файл формата jpeg, jpg, gif или png
			googEx = self.isGoodExtension (url)
			if not googEx:
				mess = wx.MessageDialog(self, config.instance().localization[u"Extension of image must be JPEG, JPG, GIF or PNG"], config.instance().localization[u"Error"], wx.OK)
				mess.ShowModal()
				return
			
			event.Skip()
		else:
			mess = wx.MessageDialog(self, config.instance().localization[u"Please, enter smile's url"], config.instance().localization[u"Error"], wx.OK)
			mess.ShowModal()

# end of class AddGroupDialog
