# -*- coding: utf-8 -*-
import os
import sys
import ConfigParser

from localization import *

class config:
	__instance = None
	
	def __init__ (self, basepath):
		self.basepath = basepath
		
		self.cacheDir = os.path.join (os.path.dirname(sys.argv[0]), os.path.join (basepath, u"cache") )
		self.imagesDir = os.path.join (os.path.dirname(sys.argv[0]), os.path.join (basepath, u"images") )
		self.configFileName = os.path.join (os.path.dirname(sys.argv[0]), os.path.join (basepath, u"config.xml") )
		self.configIniFile = os.path.join (os.path.dirname(sys.argv[0]), os.path.join (basepath, u"config.ini") )
		self.langDir = os.path.join (os.path.dirname(sys.argv[0]), os.path.join (basepath, u"lang") )
		self.archiveFileName = os.path.join (os.path.dirname(sys.argv[0]), os.path.join (basepath, u'archive.smiles') )
		
		self.localization = localization ("")
		
		self.smileextensions = [".jpeg", ".jpg", ".gif", ".png"]
		self.majorVersion = 0
		self.minorVersion = 5
		
		# Прокси
		self.useProxy = False
		self.proxyUrl = ""
		self.proxyPort = 80
		
		self.mainWindowSize = (500, 300)
		
		#
		self.splitPosition = 150
		
		self.langName = u""
		
	@staticmethod
	def instance(basepath = ''):
		if config.__instance is None:
			config.__instance = config(basepath)
			config.__instance.load ()
			
		return config.__instance
	
	
	def load (self):
		"""Загрузить параметры из файла"""
		
		try:
			fp = file (self.configIniFile)
		except:
			return		
						
		parser = ConfigParser.ConfigParser()
		parser.readfp (fp)
		
		try:
			wwidth = parser.getint (u"MainWindow", u"Width")
			wheight = parser.getint (u"MainWindow", u"Height")
			self.mainWindowSize = (wwidth, wheight)
		except:
			pass
			
		try:
			self.langName = parser.get (u"Language", u"language")
			self.localization = localization (os.path.join(self.langDir, self.langName))
		except:
			pass
			
		try:
			self.useProxy = parser.getboolean (u"Proxy", u"useproxy")
		except:
			pass
			
		try:
			self.proxyUrl = parser.get (u"Proxy", u"url")
		except:
			pass
			
		try:
			self.proxyPort = parser.getint (u"Proxy", u"port")
		except:
			pass
		
		fp.close()
	
	def save (self):
		parser = ConfigParser.ConfigParser()
		
		# Главное окно
		parser.add_section (u"MainWindow")
		
		if self.mainWindowSize[0] > 0:
			parser.set (u"MainWindow", u"Width", self.mainWindowSize[0])
			
		if self.mainWindowSize[1] > 0:
			parser.set (u"MainWindow", u"Height", self.mainWindowSize[1])
		
		# Язык
		parser.add_section (u"Language")
		langTextValue = u''
		if self.langName != None:
			langTextValue = self.langName
		parser.set (u"Language", u"language", langTextValue)
		
		# Прокси
		parser.add_section (u"Proxy")
		parser.set (u"Proxy", u"useproxy", self.useProxy)
		parser.set (u"Proxy", u"url", self.proxyUrl)
		parser.set (u"Proxy", u"port", self.proxyPort)
		
		try:
			fp = file (self.configIniFile, "w")
			parser.write (fp)
			fp.close()
		except:
			pass
			