#-*- coding: utf-8 -*-

import wx
import smilesGroupCtrl

#from smilesGroupCtrl import smileImage
from core.config import config

class smileInfoDlg(wx.Dialog):
	def __init__(self, smile, *args, **kwds):
		
		kwds["style"] = wx.DEFAULT_DIALOG_STYLE
		wx.Dialog.__init__(self, *args, **kwds)
		
		self.smile = smile
		self.URL = 1
		
		self.SetSize( (400, 168 + smile.size[1]) )
		
		#self.ok = wx.Button (self, wx.ID_OK, "")
		self.cancel = wx.Button(self, wx.ID_CANCEL, config.instance().localization[u"Close"])
		
		# Инфо о смайлике
		# Адрес картинки
		self.url_label = wx.StaticText (self, id = -1, label = config.instance().localization[u"Smile's url"])
		self.url_text = wx.TextCtrl (self, self.URL, smile.getUrl(), style=wx.TE_READONLY)
		
		
		# Ширина смайлика
		self.width_label = wx.StaticText (self, id = -1, label = config.instance().localization[u"Width"])
		self.width_text = wx.TextCtrl (self, self.URL, str (smile.size[0]), style=wx.TE_READONLY )
		
		# Высота смайлика
		self.height_label = wx.StaticText (self, id = -1, label = config.instance().localization[u"Height"])
		self.height_text = wx.TextCtrl (self, self.URL, str (smile.size[1]), style=wx.TE_READONLY )
				
		self.grid = wx.FlexGridSizer(rows=5, cols=2)
		self.grid.AddGrowableCol(1)
		self.grid.AddGrowableRow(4)
		
		# Картинка со смайликом
		self.smile_image = smilesGroupCtrl.smileImage (self, smile, (0,0))
		
		self.grid.Add (self.smile_image, 1, wx.ALL | wx.FIXED_MINSIZE, 4)
		self.grid.AddSpacer(1)
		
		# Расположем сайзеры
		
		# Инфо о смайлике
		self.grid.Add(self.url_label, 1, wx.ALIGN_LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALL, 4)
		self.grid.Add(self.url_text, 0, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL | wx.ALL, 4)
		
		self.grid.Add(self.width_label, 1, wx.ALIGN_LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALL, 4)
		self.grid.Add(self.width_text, 0, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL | wx.ALL, 4)		
		
		self.grid.Add(self.height_label, 1, wx.ALIGN_LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALL, 4)
		self.grid.Add(self.height_text, 0, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL | wx.ALL, 4)		
		
		
		# OK / Cancel
		#self.ok_cancel_sizer = wx.BoxSizer (wx.HORIZONTAL)
		#self.ok_cancel_sizer.Add(self.ok, 0, wx.ALL|wx.ALIGN_BOTTOM, 4)
		#self.ok_cancel_sizer.Add(self.cancel, 0, wx.ALL|wx.ALIGN_BOTTOM, 4)		
		
		self.grid.AddSpacer(1)
		self.grid.Add (self.cancel, 0, wx.ALL | wx.ALIGN_RIGHT | wx.ALIGN_BOTTOM, 4)
		self.SetSizer (self.grid)
		self.Layout()
		
		self.Bind(wx.EVT_CLOSE, self.OnClose)
		#self.Bind(wx.EVT_BUTTON, self.OnOk, id = wx.ID_OK)
		
		
	def OnClose (self, eventType):
		#self.EndModal(0)
		eventType.Skip()
	
	#def OnOk (self, event):
	#	event.Skip()